/* 
 * File: berkdb2csv.c
 * Author: Roger Light
 * Project: berkdb2csv
 * Date: 2006/09/06
 * Desc: Convert berkley db to csv
 * $Id: elo.c 5080 2002-10-28 04:56:55Z jdorje $
 *
 * Copyright (C) 2006 Roger Light
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <db.h>
#include "customdb.h"

void print_key_data(DBT key, DBT data);

int main(int argc, char *argv[])
{
	DB *dbp = NULL;
	DBC *cursorp;
	DBT key, data;

	char dbname[256];
	strcpy(dbname, DBNAME);

	if(db_create(&dbp, NULL, 0) != 0){
		fprintf(stderr, "Error initialising database\n");
		return 1;
	}

	if(dbp->open(dbp, NULL, dbname, NULL, DB_UNKNOWN, DB_RDONLY, 0) != 0){
		fprintf(stderr, "Error opening database\n");
		return 1;
	}

	/* Open cursor for iterating over DB */
	dbp->cursor(dbp, NULL, &cursorp, 0);
	
	/* Init DBTs */
	memset(&key, 0, sizeof(DBT));
	memset(&data, 0, sizeof(DBT));

	/* Iterate */
	while((cursorp->c_get(cursorp, &key, &data, DB_NEXT)) == 0){
		print_key_data(key, data);
	}

	/* Close cursor */
	if(cursorp){
		cursorp->c_close(cursorp);
	}

	/* Close DB */
	if(dbp){
		dbp->close(dbp, 0);
	}

	return 0;
}

